﻿using System;

namespace Arinc.Applications.Domain.Graphics.Interfaces
{
    /// <summary>
    /// Defines a graphic background or symbol image
    /// </summary>
    public interface IGraphicImage : IEquatable<IGraphicImage>
    {
        /// <summary>
        /// Gets the unique key for the image
        /// </summary>
        string Key { get; }

        /// <summary>
        /// Gets display name for the image
        /// </summary>
        string Name { get; }

        /// <summary>
        /// Gets filename for the image
        /// </summary>
        string Filename { get; }

        /// <summary>
        /// Height of the image
        /// </summary>
        float Height { get; }

        /// <summary>
        /// Width of the image
        /// </summary>
        float Width { get; }

        /// <summary>
        /// Returns the image as the specified type "T"
        /// Throws an exception if the type is not supported
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <returns></returns>
        T GetImage<T>();
    }
}
