﻿using ThinkGeo.Core;

namespace ThinkGeoPerformanceApp
{
    public class MyLineFeature : MyBaseFeature
    {
        public MyLineFeature(LineShape lineShape, int mapId, double x, double y, int col, int row, string value)
            : base(lineShape, mapId, x, y, col, row, value)
        {
            Styles.Add(CreateLineStyle());
        }

        public override RectangleShape GetPointBoundingBox(RectangleShape currentExtent, float mapHeight, float mapWidth)
        {
            return this.GetBoundingBox();
        }

        private ValueStyle CreateLineStyle()
        {
            ValueStyle valueStyle = new MyValueStyle();
            valueStyle.ColumnName = COLUMN_STATE;
            valueStyle.Name = "LineValueStyle";

            LineStyle style = new LineStyle();
            style.InnerPen = new GeoPen(GeoColors.Green, 8);
            ValueItem vi = new ValueItem();
            vi.Value = "0";
            vi.CustomStyles.Add(style);
            valueStyle.ValueItems.Add(vi);

            style = new LineStyle();
            style.InnerPen = new GeoPen(new GeoColor(75, GeoColors.Green), 8);
            vi = new ValueItem();
            vi.Value = "00";
            vi.CustomStyles.Add(style);
            valueStyle.ValueItems.Add(vi);

            style = new LineStyle();
            style.InnerPen = new GeoPen(GeoColors.Yellow, 8);
            vi = new ValueItem();
            vi.Value = "1";
            vi.CustomStyles.Add(style);
            valueStyle.ValueItems.Add(vi);

            style = new LineStyle();
            style.InnerPen = new GeoPen(new GeoColor(75, GeoColors.Yellow), 8);
            vi = new ValueItem();
            vi.Value = "11";
            vi.CustomStyles.Add(style);
            valueStyle.ValueItems.Add(vi);

            style = new LineStyle();
            style.InnerPen = new GeoPen(GeoColors.Red, 8);
            vi = new ValueItem();
            vi.Value = "2";
            vi.CustomStyles.Add(style);
            valueStyle.ValueItems.Add(vi);

            style = new LineStyle();
            style.InnerPen = new GeoPen(new GeoColor(75, GeoColors.Red), 8);
            vi = new ValueItem();
            vi.Value = "22";
            vi.CustomStyles.Add(style);
            valueStyle.ValueItems.Add(vi);

            style = new LineStyle();
            style.InnerPen = new GeoPen(GeoColors.Orange, 8);
            vi = new ValueItem();
            vi.Value = "3";
            vi.CustomStyles.Add(style);
            valueStyle.ValueItems.Add(vi);

            style = new LineStyle();
            style.InnerPen = new GeoPen(new GeoColor(75, GeoColors.Orange), 8);
            vi = new ValueItem();
            vi.Value = "33";
            vi.CustomStyles.Add(style);
            valueStyle.ValueItems.Add(vi);

            return valueStyle;
        }
    }
}
