﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

using ThinkGeo.Core;

namespace ThinkGeoPerformanceApp
{
    public class MyShapeFeature : MyBaseFeature
    {
        public MyShapeFeature(BaseShape shape, int mapId, double x, double y, int col, int row, string value)
            : base(shape, mapId, x, y, col, row, value)
        {
            Styles.Add(CreateShapeStyle());
        }

        public override RectangleShape GetPointBoundingBox(RectangleShape currentExtent, float mapHeight, float mapWidth)
        {
            return this.GetBoundingBox();
        }

        private ValueStyle CreateShapeStyle()
        {
            ValueStyle valueStyle = new MyValueStyle();
            valueStyle.ColumnName = COLUMN_STATE;
            valueStyle.Name = "ShapeValueStyle";

            AreaStyle style = new AreaStyle(GeoPens.Black, GeoBrushes.Green);
            ValueItem vi = new ValueItem();
            vi.Value = "0";
            vi.CustomStyles.Add(style);
            valueStyle.ValueItems.Add(vi);

            style = new AreaStyle(GeoPens.Black, new GeoSolidBrush(new GeoColor(75, GeoColors.Green)));
            vi = new ValueItem();
            vi.Value = "00";
            vi.CustomStyles.Add(style);
            valueStyle.ValueItems.Add(vi);

            style = new AreaStyle(GeoPens.Black, GeoBrushes.Yellow);
            vi = new ValueItem();
            vi.Value = "1";
            vi.CustomStyles.Add(style);
            valueStyle.ValueItems.Add(vi);

            style = new AreaStyle(GeoPens.Black, new GeoSolidBrush(new GeoColor(75, GeoColors.Yellow)));
            vi = new ValueItem();
            vi.Value = "11";
            vi.CustomStyles.Add(style);
            valueStyle.ValueItems.Add(vi);

            style = new AreaStyle(GeoPens.Black, GeoBrushes.Red);
            vi = new ValueItem();
            vi.Value = "2";
            vi.CustomStyles.Add(style);
            valueStyle.ValueItems.Add(vi);

            style = new AreaStyle(GeoPens.Black, new GeoSolidBrush(new GeoColor(75, GeoColors.Red)));
            vi = new ValueItem();
            vi.Value = "22";
            vi.CustomStyles.Add(style);
            valueStyle.ValueItems.Add(vi);

            style = new AreaStyle(GeoPens.Black, GeoBrushes.Orange);
            vi = new ValueItem();
            vi.Value = "3";
            vi.CustomStyles.Add(style);
            valueStyle.ValueItems.Add(vi);

            style = new AreaStyle(GeoPens.Black, new GeoSolidBrush(new GeoColor(75, GeoColors.Orange)));
            vi = new ValueItem();
            vi.Value = "33";
            vi.CustomStyles.Add(style);
            valueStyle.ValueItems.Add(vi);

            return valueStyle;
        }

    }
}
